program NkV;

uses Windows, Messages, NSys, NLib, NUtil, NForm, MainForm, ImgFilter;

{$R *.RES}

var
  Form: TNkVMainForm;
  list: TFileList;
  i: Integer;
  fname: string;
  loadpos: Boolean;
  stdin: Boolean;
  x, y, w, h: Integer;
  rc: TRect;
begin
  AppName := 'NkV';
  ProfDir := GetEnv('NKTOOLSPROF', '');
  if ProfDir = '' then
    ProfDir := DirName(AbsPath(Argv[0]))
  else
    ProfDir := JoinPath(ProfDir, Lower(AppName));

  loadpos := FindWindow(PChar(string(TNkVMainForm.ClassName)), nil) = 0;

  list := TFileList.Create;
  Form := TNkVMainForm.CreateDefaultPos(AppName, 320, 240);
  try
    SetMainForm(Form);

    if loadpos then
      LoadFormPos(ProfDir, Form);  

    Form.LoadConfig;

    for i := 1 to Argc-1 do
      if IsDir(Argv[i]) then
      begin
        Form.DirMode := (Argc-1) = 1;
        with TListDir.Create(Argv[i]) do
          try
            while Each(fname) do
              if not IsDir then
                list.Add(AbsPath(JoinPath(Argv[i], fname)));
          finally
            Free;
          end
      end else
        list.Add(AbsPath(Argv[i]));
    list.Sort(StrColl);
    stdin := list.Count = 0;
    if stdin then 
      list.Add('');
    Form.LoadFirstFile(list);
    list.Free;

    if not stdin then
      if Form.FileList.Count = 0 then
      begin
        ExitCode := 1;
        Exit;
      end
      else if Form.FileList.Count = 1 then
      begin
        Form.DirMode := True;
        Form.FileListUpdate := True;
      end;
  
    if Form.Image.Loaded then
    begin
      Form.GetBounds(x, y, w, h);
      rc := GetMonitorRectFromPoint(x, y);
      if (x+w) > rc.Right then
        x := rc.Right-w;
      if (y+h) > rc.Bottom then
        y := rc.Bottom-h;
      if x < rc.Left then
        x := rc.Left;
      if y < rc.Top then
        y := rc.Top;
      Form.SetPosition(x, y);
    end;

    Form.Show;
    ExitCode := MessageLoop;
  finally
    Form.Free;
  end;
end.
